#include <iostream>
#include <ctime>
#include <queue>
#include <iterator>
#include <set>

#include "stav.h"

using namespace std;

typedef pair<int,stav> dis;

bool operator>(const dis& lhs,const dis& rhs) {
   return (lhs.first>rhs.first);
}

int h(const stav& st) {
   int chyb = 0;
   for (int i = 1; i<4; i++) {
      if (st.policko(i,1) != (i + '0')) {
         chyb++;
      }
   }
   for (int i = 5; i<8; i++) {
      if (st.policko(7-i,3) != (i + '0')) {
         chyb++;
      }
   }
   if (st.policko(1,2) != (8 + '0')) {
      chyb++;
   }
   if (st.policko(3,2) != (4 + '0')) {
      chyb++;
   }
   return chyb;
}



int main() {
   unsigned start = (unsigned)time(0);
   srand(start);
   stav st1;
   cout << "Stav 1:\n";
   for (int i = 0; i<9; i++) {
      cout << st1.policko((i%3) + 1, (i/3) + 1);
      if ((i%3) < 2) {
         cout << " | ";
      } else {
         cout << endl;
      }
   }
   cout << endl << endl;
   priority_queue<dis,vector<dis>,greater<dis> > fronta;
   set<string> S;
   fronta.push(dis(h(st1),st1));
   S.insert(st1.hash());
   bool vyreseno = false;
   stav vysledek;
   stav *as,*sr,*sl,*su,*sd;
   int pocet_stavu = 0;   
   
   while (!vyreseno) {
      as = new stav(fronta.top().second);fronta.pop();
       
      sl = new stav(*as);sr = new stav(*as); su = new stav(*as); sd = new stav(*as);
      if (sl->doleva()) {
         if (S.find(sl->hash()) == S.end()) {
            pocet_stavu++;
            if (sl->konec()) {
               vysledek = *sl;
               vyreseno = true;
            } else {
               fronta.push(dis(h(*sl) + sl->pohybu(),*sl));
               S.insert(sl->hash());
            }
         }
      }
      if (sr->doprava()){
         if (S.find(sr->hash()) == S.end()) {
            pocet_stavu++;
            if (sr->konec()) {
               vysledek = *sr;
               vyreseno = true;
            } else {
               fronta.push(dis(h(*sr) + sr->pohybu(),*sr));
               S.insert(sr->hash());
            }
         }
      }
      if (sd->dolu()) {
         if (S.find(sd->hash()) == S.end()) {
            pocet_stavu++;
            if (sd->konec()) {
               vysledek = *sd;
               vyreseno = true;
            } else {
               fronta.push(dis(h(*sd) + sl->pohybu(),*sd));
               S.insert(sd->hash());
            }
         }
      }
      if (su->nahoru()) {
         if (S.find(su->hash()) == S.end()) {
            pocet_stavu++;
            if (su->konec()) {
               vysledek = *su;
               vyreseno = true;
            } else {
               fronta.push(dis(h(*su) + su->pohybu(),*su));
               S.insert(su->hash());
            }
         }
      }
      
   }
   cout << "Vysledek 1:\n";
   for (int i = 0; i<9; i++) {
      cout << vysledek.policko((i%3) + 1, (i/3) + 1);
      if ((i%3) < 2) {
         cout << " | ";
      } else {
         cout << endl;
      }
   }
   cout << "Historie: " << vysledek.historie() <<endl;
   return 0;
}
      
