#include "stav.h"
#include <cstdlib>
#include <iostream>

stav::stav(){
   pole[0][0] = '1'; pole[0][1] = '2'; pole[0][2] = '3';
   pole[1][0] = '8'; pole[1][1] = ' '; pole[1][2] = '4';
   pole[2][0] = '7'; pole[2][1] = '6'; pole[2][2] = '5';
   int pocet_pohybu = (rand()%500) + 1000;
   mx = 1;
   my = 1;
   mc = 0;
   for (int i = 0; i < pocet_pohybu; i++) {
      int p = rand() % 4;
      char pom;
      // 0 vpravo (dolu, nahoru)
      // 1 vlevo  (nahoru, dolu)
      // 2 nahoru (vlevo, vpravo)
      // 3 dolu   (vpravo, vlevo)
      if (((p == 0)&&(mx<2)) || 
          ((p == 2)&&(my<1)&&(mx<1)) || 
          ((p == 3)&&(my>1)&&(mx<2))
         ){ //vpravo
         pom = pole[my][mx+1];
         pole[my][mx+1] = pole[my][mx];
         pole[my][mx] = pom;
         mx++;
      } else if (((p == 1)&&(mx>0)) ||
                 ((p == 2)&&(my<1)&&(mx>0)) ||
                 ((p == 3)&&(my>1)&&(mx>1))
                 ){ //vlevo
                    pom = pole[my][mx-1];
                    pole[my][mx-1] = pole[my][mx];
                    pole[my][mx] = pom;
                    mx--;
      } else if (((p == 2)&&(my>0)) ||
                 ((p == 0)&&(mx>1)&&(my>1)) ||
                 ((p == 1)&&(mx<1)&&(my>0))
                 ) { //nahoru
                    pom = pole[my-1][mx];
                    pole[my-1][mx] = pole[my][mx];
                    pole[my][mx] = pom;
                    my--;
      } else {
         //dolu
         pom = pole[my+1][mx];
         pole[my+1][mx] = pole[my][mx];
         pole[my][mx] = pom;
         my++;
      }
   }
   path = string();
}

//stav::stav(const stav& s){
//}

const char stav::policko(const int x, const int y) const {
   if ((x<1)||(x>3)||(y<1)||(y>3)) {
      return '?';
   } else {
      return pole[y-1][x-1];
   }
}

const bool stav::nahoru(){
   char pom;
   if (my<1) {
      return false;
   } else {
      pom = pole[my-1][mx];
      pole[my-1][mx] = pole[my][mx];
      pole[my][mx] = pom;
      my--;
      path += "u";
      mc++;
      if (pole[my][mx] != ' ') {
         cerr << "CHYBA 1u\n";
      }
      if ((mx<0) || (mx>2) || (my<0) || (my>2)) {
         cerr << "CHYBA 2u\n";
      }
      return true;
   }   
}

const bool stav::dolu(){
   char pom;
   if (my>1) {
      return false;
   } else {
      pom = pole[my+1][mx];
      pole[my+1][mx] = pole[my][mx];
      pole[my][mx] = pom;
      my++;
      path += "d";
      mc++;
      if (pole[my][mx] != ' ') {
         cerr << "CHYBA 1d\n";
      }
      if ((mx<0) || (mx>2) || (my<0) || (my>2)) {
         cerr << "CHYBA 2d\n";
      }
      return true;
   }   
}

const bool stav::doleva(){
   char pom;
   if (mx<1) {
      return false;
   } else {
      pom = pole[my][mx-1];
      pole[my][mx-1] = pole[my][mx];
      pole[my][mx] = pom;
      mx--;
      path += "l";
      mc++;
      if (pole[my][mx] != ' ') {
         cerr << "CHYBA 1l\n";
      }
      if ((mx<0) || (mx>2) || (my<0) || (my>2)){
         cerr << "CHYBA 2l\n";
      }
      return true;
   }   
}

const bool stav::doprava(){
   char pom;
   if (mx>1) {
      return false;
   } else {
      pom = pole[my][mx+1];
      pole[my][mx+1] = pole[my][mx];
      pole[my][mx] = pom;
      mx++;
      path += "r";
      mc++;
      if (pole[my][mx] != ' ') {
         cerr << "CHYBA 1r\n";
      }
      if ((mx<0) || (mx>2) || (my<0) || (my>2)){
         cerr << "CHYBA 2r\n";
      }
      return true;
   }   
}

const bool stav::konec() const {
   if (pole[0][0] != '1') {
      return false;
   }
   if (pole[0][1] != '2') {
      return false;
   }
   if (pole[0][2] != '3') {
      return false;
   }
   if (pole[1][0] != '8') {
      return false;
   }
   if (pole[1][1] != ' ') {
      return false;
   }
   if (pole[1][2] != '4') {
      return false;
   }
   if (pole[2][0] != '7') {
      return false;
   }
   if (pole[2][1] != '6') {
      return false;
   }
   return true;
}

string stav::hash() const {
   string ret = "";
   for (int i = 0; i<9; i++) {
      ret += pole[i/3][i%3];
   }
   return ret;
}

string stav::historie() const {
   return path;
}

int stav::pohybu() const {
   return mc;
}
