#!/usr/bin/perl
use strict;
use warnings;

our @stav = ('-','\\','|','/');

sub man {
   my $sum = 0;
   my $cnt = 0;
   my $min = shift;
   my $max = shift;
   $$min = 99;
   $$max = 0;
   print STDERR " ";
   for (my $i = 0; $i<100; $i++) {
      open(INPUT,"time ./manhattan 2>&1|") || die "$!\n";
      while (<INPUT>) {
         if (s/([\d\.]*)elapsed/ee/) {
            $sum += $1;
            $cnt++;
            if ($1>$$max) {
               $$max = $1;
            }
            if ($1<$$min) {
               $$min = $1;
            }
            print STDERR "\b", $stav[$cnt % 4];
            #print "$1\n";
         }
      }
      close INPUT;
      sleep 2;
   }
   print STDERR "\b";
   return ($sum/$cnt);
}

sub chyb {
   my $sum = 0;
   my $cnt = 0;
   my $min = shift;
   my $max = shift;
   $$min = 99;
   $$max = 0;
   print STDERR " ";
   for (my $i = 0; $i<100; $i++) {
      open(INPUT,"time ./chybne_umisteni 2>&1|") || die "$!\n";
      while (<INPUT>) {
         if (s/([\d\.]*)elapsed/ee/) {
            $sum += $1;
            $cnt++;
            if ($1>$$max) {
               $$max = $1;
            }
            if ($1<$$min) {
               $$min = $1;
            }
            print STDERR "\b", $stav[$cnt % 4];
            #print "$1\n";
         }
      }
      close INPUT;
      sleep 2;
   }
   print STDERR "\b";
   return ($sum/$cnt);
}

print STDERR "Chybne umisteni: ";
my ($min,$max);
print STDERR chyb(\$min,\$max), "\b\n";
print STDERR "\tMin: $min\tMax: $max\n"; 
print STDERR "Manhattan      : ";
print STDERR man(\$min,\$max), "\n";
print STDERR "\tMin: $min\tMax: $max\n";

